/*!
 * devextreme-angular
 * Version: 24.1.1-alpha-24082-1039
 * Build date: Fri Mar 22 2024
 *
 * Copyright (c) 2012 - 2024 Developer Express Inc. ALL RIGHTS RESERVED
 *
 * This software may be modified and distributed under the terms
 * of the MIT license. See the LICENSE file in the root of the project for details.
 *
 * https://github.com/DevExpress/devextreme-angular
 */
import { OnInit, OnDestroy, EventEmitter, QueryList } from '@angular/core';
import { Properties as dxSplitterOptions } from 'devextreme/ui/splitter';
import { NestedOptionHost } from 'devextreme-angular/core';
import { DxoSplitterOptions } from './base/splitter-options';
import { DxiItemComponent } from './item-dxi';
import * as i0 from "@angular/core";
export declare class DxoSplitterComponent extends DxoSplitterOptions implements OnDestroy, OnInit {
    /**
    
     * This member supports the internal infrastructure and is not intended to be used directly from your code.
    
     */
    itemsChange: EventEmitter<Array<string | any | {
        collapsed?: boolean;
        collapsedSize?: number | string | undefined;
        collapsible?: boolean;
        disabled?: boolean;
        maxSize?: number | string | undefined;
        minSize?: number | string | undefined;
        resizable?: boolean;
        size?: number | string | undefined;
        splitter?: dxSplitterOptions | undefined;
        template?: any;
        text?: string;
        visible?: boolean;
    }>>;
    protected get _optionPath(): string;
    get itemsChildren(): QueryList<DxiItemComponent>;
    set itemsChildren(value: QueryList<DxiItemComponent>);
    constructor(parentOptionHost: NestedOptionHost, optionHost: NestedOptionHost);
    ngOnInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSplitterComponent, [{ host: true; skipSelf: true; }, { host: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<DxoSplitterComponent, "dxo-splitter", never, { "allowKeyboardNavigation": "allowKeyboardNavigation"; "dataSource": "dataSource"; "disabled": "disabled"; "elementAttr": "elementAttr"; "height": "height"; "hoverStateEnabled": "hoverStateEnabled"; "items": "items"; "itemTemplate": "itemTemplate"; "onContentReady": "onContentReady"; "onDisposing": "onDisposing"; "onInitialized": "onInitialized"; "onItemClick": "onItemClick"; "onItemCollapsed": "onItemCollapsed"; "onItemContextMenu": "onItemContextMenu"; "onItemExpanded": "onItemExpanded"; "onItemRendered": "onItemRendered"; "onOptionChanged": "onOptionChanged"; "onResize": "onResize"; "onResizeEnd": "onResizeEnd"; "onResizeStart": "onResizeStart"; "orientation": "orientation"; "repaintChangesOnly": "repaintChangesOnly"; "rtlEnabled": "rtlEnabled"; "separatorSize": "separatorSize"; "visible": "visible"; "width": "width"; }, { "itemsChange": "itemsChange"; }, ["itemsChildren"], never>;
}
export declare class DxoSplitterModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<DxoSplitterModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<DxoSplitterModule, [typeof DxoSplitterComponent], never, [typeof DxoSplitterComponent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<DxoSplitterModule>;
}
